.386

.MODEL	FLAT, stdcall
option	casemap:none
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
include c:\masm32\include\ntfs.inc
include c:\masm32\include\windows.inc
include c:\masm32\include\kernel32.inc
include    \masm32\include\advapi32.inc
include c:\masm32\include\user32.inc
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\advapi32.lib
assume fs:nothing

.const

IOCTL_FFSD_STARTHOOK	equ 83000000h
IOCTL_FFSD_ENABLEBPX	equ 83000005h
FILE_FLAG_BACKUP_SEMANTICS equ 02000000h
ERROR_SERVICE_EXIST	equ 431h
SC_MANAGER_ALL_ACCESS  	equ STANDARD_RIGHTS_REQUIRED OR 03FH
SERVICE_ALL_ACCESS     	equ STANDARD_RIGHTS_REQUIRED OR 1FFH
SERVICE_KERNEL_DRIVER  	equ 001H
SERVICE_DEMAND_START   	equ 003H
SERVICE_ERROR_NORMAL   	equ 001H
SERVICE_CONTROL_STOP   	equ 001H
BS_DEFPUSHBUTTON    	equ 1
ButtonID1		equ 1
ChkID			equ 2

.data
DosDeviceName   	db "\\.\"
DriverName      	db "ffsd",0
_ServiceExe     	db "\ffsd.sys",0
FSD			db "\\.\ffsd",0
drivername		db "ffsd.sys",0
TxtTitle		db "FFSD Loader",0
TxtOK			db "FFSD Active!",0
MsgErr			db "Error Open SCM",0
MsgErr2			db "Error in Creating Service",0
MsgErr3			db "Error in Starting service",0
MsgErr4			db "Error I can't find ffsd.sys :(",0
ErrOpenSys		db "Error opening FFSD driver",0
ID_IOCTL		dd 83000000h
OPT_BUFFER		dd 00000001h
OPT_BUFFER2		dd 00000001h
HndFSD			dd 0
ByteReceived		dd 0
ClassName 		db "SimpleWinClass",0
AppName  		db "FFsd Loader ;)",0
ButtonClassName 	db "button",0
ButtonText1		db "Load FFsd driver",0
ChkText			db "Enable/Disable 'IRP_MJ_READ' bpx",0
TextWarning		db "Make sure to have Softice (or any system debugger) Loaded!!",0
capt			db "Warning!",0

.data?
schSCManager    	dd ?
schService      	dd ?
hwndButton1		HWND ?
hwndChk			HWND ?
hInstance 		HINSTANCE ?
CommandLine 		LPSTR ?
path            	db 260 dup(?)
ps  RECT		<>
Wi_d			dd ?
Hi_d			dd ?
Wi_Desk_half		dd ?
Hi_Desk_half		dd ?
X_pos			dd ?
Y_pos			dd ?

.code

start:

		invoke GetModuleHandle, NULL
		mov    hInstance,eax
		invoke GetCommandLine
		mov CommandLine,eax
		invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND
		mov   wc.cbSize,SIZEOF WNDCLASSEX
		mov   wc.style, CS_HREDRAW or CS_VREDRAW
		mov   wc.lpfnWndProc, OFFSET WndProc
		mov   wc.cbClsExtra,NULL
		mov   wc.cbWndExtra,NULL
		push  hInst
		pop   wc.hInstance
		mov   wc.hbrBackground,COLOR_WINDOW+1
		mov   wc.lpszMenuName,NULL
		mov   wc.lpszClassName,OFFSET ClassName
		invoke LoadIcon,NULL,IDI_APPLICATION
		mov   wc.hIcon,eax
		mov   wc.hIconSm,eax
		invoke LoadCursor,NULL,IDC_ARROW
		mov   wc.hCursor,eax
		invoke RegisterClassEx, addr wc
		
		call  CentraDialog
		
		INVOKE CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
           		WS_CAPTION+WS_SYSMENU+WS_MINIMIZEBOX+WS_VISIBLE,X_pos,\
           		Y_pos,280,100,NULL,NULL,\
           		hInst,NULL
		mov   hwnd,eax
		INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
		INVOKE UpdateWindow, hwnd
		.WHILE TRUE
		    	INVOKE GetMessage, ADDR msg,NULL,0,0
                	.BREAK .IF (!eax)
                	INVOKE TranslateMessage, ADDR msg
                	INVOKE DispatchMessage, ADDR msg
		.ENDW
		mov     eax,msg.wParam
		ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
		.IF uMsg==WM_DESTROY
			invoke 	PostQuitMessage,NULL
		
		.ELSEIF uMsg==WM_CREATE
			invoke 	CreateWindowEx,NULL, ADDR ButtonClassName,ADDR ButtonText1,\
                        	WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,\
                        	5,40,260,25,hWnd,ButtonID1,hInstance,NULL
			mov  	hwndButton1,eax
			invoke 	CreateWindowEx,NULL, ADDR ButtonClassName,ADDR ChkText,\
                        	WS_CHILD or WS_VISIBLE or BS_CHECKBOX or BS_AUTOCHECKBOX or WS_DISABLED,\
                        	5,10,260,25,hWnd,ChkID,hInstance,NULL
                		mov  hwndChk,eax
			
		.ELSEIF uMsg==WM_COMMAND
			mov 	eax,wParam
			.if 	ax==ButtonID1
			
				call 	LoadFFsd
			
			.elseif ax==ChkID
			
				invoke  MessageBoxA,hWnd,offset TextWarning,offset capt,MB_ICONWARNING or MB_OKCANCEL
				cmp 	eax,IDCANCEL
				jz      NoNow
				invoke  DeviceIoControl,HndFSD,IOCTL_FFSD_ENABLEBPX,offset OPT_BUFFER,00000004,offset OPT_BUFFER2,00000004,offset ByteReceived,0
NoNow:
			.endif
		.ELSE
			invoke 	DefWindowProc,hWnd,uMsg,wParam,lParam
			ret
		.ENDIF
		xor    eax,eax
		ret
WndProc endp

;******************************************************************************
;	Load FFsd driver
; In  -> none
; Out -> none
;******************************************************************************	
LoadFFsd	proc

		push     offset path
        	push     260
           	call     GetCurrentDirectoryA
           	
           	invoke 	 CreateFileA,offset drivername,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
           	cmp      eax,-1
           	jz       Whereis
           	invoke   CloseHandle,eax
               
              	push     offset _ServiceExe
             	push     offset path
             	call     lstrcat

            	xor      esi,esi
              	push     SC_MANAGER_ALL_ACCESS
             	push     esi
             	push     esi
            	call     OpenSCManagerA
            	mov   	schSCManager,eax
		xor   	eax,esi
            	jz    	Error
               
		push   	esi
		push  	esi
		push   	esi
		push   	esi
		push   	esi
		push  	offset path
		push   	SERVICE_ERROR_NORMAL
  		push  	SERVICE_DEMAND_START
		push   	SERVICE_KERNEL_DRIVER
		push   	SERVICE_ALL_ACCESS       
		push  	offset DriverName
		push  	offset DriverName
		push  	schSCManager
		call  	CreateServiceA
               		
		mov   	[schService],eax
		xor   	eax,esi
		jz    	Failed1
               
		push   	NULL
		push  	0
		push   	eax
		call   	StartServiceA
		cmp    	eax,0
		jz     	Failed2
               
		invoke  MessageBoxA,NULL,offset TxtOK,offset TxtTitle,MB_OK
		invoke 	CreateFileA,offset FSD,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
		cmp    	eax,-1
		jnz    	FSDOpened
		invoke 	MessageBoxA,0,offset ErrOpenSys ,offset TxtTitle,MB_OK
		ret
FSDOpened:
		mov    	[HndFSD],eax		
		invoke  DeviceIoControl,HndFSD,IOCTL_FFSD_STARTHOOK,offset OPT_BUFFER,00000004,offset OPT_BUFFER2,00000004,offset ByteReceived,0
		invoke 	EnableWindow, hwndChk,1
		invoke 	EnableWindow, hwndButton1,0
		ret
Error:
           	invoke 	MessageBoxA, NULL,offset MsgErr, offset TxtTitle, MB_OK
           	ret
Failed1:
		invoke 	MessageBoxA, NULL,offset MsgErr2, offset TxtTitle, MB_OK
		ret
Whereis:
		invoke 	MessageBoxA, NULL,offset MsgErr4, offset TxtTitle, MB_OK
		ret
Failed2:
		invoke 	MessageBoxA, NULL,offset MsgErr3, offset TxtTitle, MB_OK
		push   	dword ptr [schService]
		call   	DeleteService
AlreadyLoaded:
		ret
		
LoadFFsd	endp

;******************************************************************************
;	Just center the main dialog ...nice coding
; In  -> none
; Out -> none
;******************************************************************************	
CentraDialog proc

	    	invoke GetDesktopWindow
	    	invoke GetClientRect,eax,offset ps
	    	mov  eax,ps.right
	    	mov  ecx,2
	    	xor  edx,edx
	    	idiv  ecx
	    	mov  Wi_Desk_half, eax
	    	mov  eax,ps.bottom
	    	mov  ecx,2
	    	xor  edx,edx
	    	idiv  ecx
	    	mov  Hi_Desk_half, eax
	    
	    	mov  eax,280
	    	mov  [Wi_d],eax
	    	mov  ecx,2
	    	xor  edx,edx
	    	idiv  ecx
	    	mov  ecx,Wi_Desk_half
	    	sub  ecx,eax
	    	mov  X_pos,ecx
	    
	    	mov  eax,100
	    	mov  [Hi_d],eax
	    	mov  ecx,2
	    	xor  edx,edx
	    	idiv  ecx
	    	mov  ecx,Hi_Desk_half
	    	sub  ecx,eax
	    	mov  Y_pos,ecx
	    	ret

CentraDialog endp

end start